#include "FrequenciesCombo.h"

#include <qfile.h>
#include <qtextstream.h>
#include <qpe/qpeapplication.h> 

FrequenciesCombo::FrequenciesCombo(QWidget * parent=0, const char * name=0)
	: QComboBox(parent, name)
{
    QFile f(QPEApplication::documentDir() + "../" + "Settings/freqchange.conf");
    if (f.open(IO_ReadOnly)) 
    {
        QTextStream t(&f);
        QString s;
        while (!t.eof()) 
        {
            s = t.readLine();
			
			bool ok;
			int sep = s.find(',');
			QString title = s.left(sep);
			int clock = s.right(s.length() - s.find(',') - 1).toInt(&ok, 16);

			if ((sep != -1) &&  (title != "") && (ok == TRUE) && clock ) 
			{
				frequencies[title] = clock;
				insertItem(title);
			}
        }
        f.close();
    }
}

void FrequenciesCombo::setCurrentFrequency(int freq)
{
	for (int i = 0; i < count(); ++i) 
	{
		if (frequencies[text(i)] == freq)
		{
			setCurrentItem(i);
			break;
		}
	}
}

int FrequenciesCombo::currentFrequency()
{
	return frequencies[currentText()];
}

